package fr.username404.snowygui

import fr.username404.snowygui.gui.ColoredElement
import fr.username404.snowygui.gui.Element
import fr.username404.snowygui.gui.SnowyScreen
import fr.username404.snowygui.gui.elements.ClickBox

object ClickGui: SnowyScreen() {
    private var GuiDragging: Boolean = false
    override val components = mutableSetOf<Element>()

    val clickBoxes get() = components.filterIsInstance<ClickBox>()
    inline fun boxContext(args: ClickBox.() -> Unit) = components.filterIsInstance<ClickBox>().forEach(args)
    private inline fun buttonsContext(args: ColoredElement.() -> Unit) = boxContext { buttons.forEach(args) }
    override fun mouseClicked(d: Double, e: Double, i: Int): Boolean { buttonsContext { this.mouseClicked(d, e, i) }; return false }
    override fun mouseReleased(d: Double, e: Double, i: Int): Boolean { buttonsContext { this.mouseReleased(d, e, i) }; return false }
    override fun mouseScrolled(d: Double, e: Double, f: Double): Boolean { boxContext { scroll(d, e, f) }; return false }
    override fun mouseDragged(d: Double, e: Double, i: Int, f: Double, g: Double): Boolean {
        if (i == 0) {
            components.forEach {
                if (it.withinBounds(d, e) and !GuiDragging) {
                    GuiDragging = true
                    it.x = d.minus(f) + (d - (it.x + it.width))
                    it.y = e.minus(g) + (e - (it.y + it.height))
                } else GuiDragging = false
            }
        }
        return super.mouseDragged(d, e, i, f, g)
    }
}